// HanAutomata.h: interface for the _CHanAutomata class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_HANAUTOMATA_H__4D84A6D4_B43D_427E_8DF3_FC2BED557300__INCLUDED_)
#define AFX_HANAUTOMATA_H__4D84A6D4_B43D_427E_8DF3_FC2BED557300__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CHanAutomata  
{
public:
	int setString(LPCTSTR pszStr);
	int getUnicode(WCHAR *pBuf);

	CHanAutomata();
	virtual ~CHanAutomata();

	void clear();
	int addChar(char ch);

	static WORD getCode(char ch);

protected:
	WORD makeUnicode();
	void complete();
	void appendCode(WORD code);
	BYTE m_jamo[3];
	BYTE &cho, &jung, &jong;
	WORD m_szBuf[1024];
	int m_curr;
	int m_bul;
	enum _BL_STAT { BLS_NULL = -1, BLS_CHO = 0, BLS_JUNG = 1, BLS_JONG = 2 };
	static const BYTE s_cnvtbl[][4];
	static const struct _KeyCode {
		char ch; BYTE cod, bul, reserved;
	} s_3bulKeys[], s_2bulKeys[];
};

#endif // !defined(AFX_HANAUTOMATA_H__4D84A6D4_B43D_427E_8DF3_FC2BED557300__INCLUDED_)
